/* tslint:disable */
/* eslint-disable */
/**
 * PAYMENTS API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface AvailableActionsResponse
 */
export interface AvailableActionsResponse {
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'unzer': Array<AvailableActionsResponseUnzerEnum>;
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'paypal': Array<AvailableActionsResponsePaypalEnum>;
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'custom': Array<AvailableActionsResponseCustomEnum>;
}

export const AvailableActionsResponseUnzerEnum = {
    CreatePaymentLink: 'create_payment_link'
} as const;

export type AvailableActionsResponseUnzerEnum = typeof AvailableActionsResponseUnzerEnum[keyof typeof AvailableActionsResponseUnzerEnum];
export const AvailableActionsResponsePaypalEnum = {
    PayAnotherAccount: 'pay_another_account',
    CreatePaymentLink: 'create_payment_link'
} as const;

export type AvailableActionsResponsePaypalEnum = typeof AvailableActionsResponsePaypalEnum[keyof typeof AvailableActionsResponsePaypalEnum];
export const AvailableActionsResponseCustomEnum = {
    CreatePaymentLink: 'create_payment_link'
} as const;

export type AvailableActionsResponseCustomEnum = typeof AvailableActionsResponseCustomEnum[keyof typeof AvailableActionsResponseCustomEnum];

/**
 * 
 * @export
 * @interface CreatePaymentLinkWebhook
 */
export interface CreatePaymentLinkWebhook {
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'contact_id': string;
    /**
     * 
     * @type {object}
     * @memberof CreatePaymentLinkWebhook
     */
    'attributes'?: object;
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'payment_link': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentLinkWebhook
     */
    'payment_id': string;
}
/**
 * 
 * @export
 * @interface CreatePaypalConfigRequest
 */
export interface CreatePaypalConfigRequest {
    /**
     * 
     * @type {string}
     * @memberof CreatePaypalConfigRequest
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaypalConfigRequest
     */
    'client_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreatePaypalConfigRequest
     */
    'client_secret': string;
}
/**
 * 
 * @export
 * @interface CreateUnzerConfigRequest
 */
export interface CreateUnzerConfigRequest {
    /**
     * 
     * @type {string}
     * @memberof CreateUnzerConfigRequest
     */
    'public_key': string;
    /**
     * 
     * @type {string}
     * @memberof CreateUnzerConfigRequest
     */
    'private_key': string;
    /**
     * 
     * @type {string}
     * @memberof CreateUnzerConfigRequest
     */
    'api_url': string;
}
/**
 * 
 * @export
 * @interface CustomHandler
 */
export interface CustomHandler {
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'type': CustomHandlerTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'url': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret'?: string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret_header'?: string;
    /**
     * 
     * @type {boolean}
     * @memberof CustomHandler
     */
    'secret_configured': boolean;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'attributes'?: string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'updated_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'organization_id': string;
}

export const CustomHandlerTypeEnum = {
    CreatePaymentLink: 'create_payment_link'
} as const;

export type CustomHandlerTypeEnum = typeof CustomHandlerTypeEnum[keyof typeof CustomHandlerTypeEnum];

/**
 * 
 * @export
 * @interface PaypalConfiguration
 */
export interface PaypalConfiguration {
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'client_id': string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'webhook_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof PaypalConfiguration
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface UnzerConfiguration
 */
export interface UnzerConfiguration {
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'public_key': string;
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof UnzerConfiguration
     */
    'updated_at': string;
}

/**
 * CustomApi - axios parameter creator
 * @export
 */
export const CustomApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('getCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers: async (channelId: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('listCustomHandlers', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers: async (orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listOrganizationCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook: async (type: OrganizationWebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'type' is not null or undefined
            assertParamExists('organizationWebhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('organizationWebhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/webhooks/{type}`
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler: async (channelId: string, orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('registerCustomHandler', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler: async (orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook: async (channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('webhook', 'channelId', channelId)
            // verify required parameter 'type' is not null or undefined
            assertParamExists('webhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('webhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/webhooks/{type}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CustomApi - functional programming interface
 * @export
 */
export const CustomApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CustomApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listCustomHandlers(channelId, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listOrganizationCustomHandlers(orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationWebhook(type, orgId, body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerCustomHandler(channelId, orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerOrganizationCustomHandler(orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.webhook(channelId, type, orgId, body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CustomApi - factory interface
 * @export
 */
export const CustomApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CustomApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers(channelId: string, orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listCustomHandlers(channelId, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers(orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listOrganizationCustomHandlers(orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: any): AxiosPromise<void> {
            return localVarFp.organizationWebhook(type, orgId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreatePaymentLinkWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: any): AxiosPromise<void> {
            return localVarFp.webhook(channelId, type, orgId, body, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CustomApi - object-oriented interface
 * @export
 * @class CustomApi
 * @extends {BaseAPI}
 */
export class CustomApi extends BaseAPI {
    /**
     * 
     * @summary Delete custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List custom handlers
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listCustomHandlers(channelId, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List organization custom handlers
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listOrganizationCustomHandlers(orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook (organization)
     * @param {OrganizationWebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {CreatePaymentLinkWebhook} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).organizationWebhook(type, orgId, body, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register custom handler
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register organization custom handler
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook
     * @param {string} channelId 
     * @param {WebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {CreatePaymentLinkWebhook} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreatePaymentLinkWebhook, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).webhook(channelId, type, orgId, body, options).then((request) => request(this.axios, this.basePath));
    }
}

/**
 * @export
 */
export const OrganizationWebhookTypeEnum = {
    CreatePaymentLink: 'create_payment_link'
} as const;
export type OrganizationWebhookTypeEnum = typeof OrganizationWebhookTypeEnum[keyof typeof OrganizationWebhookTypeEnum];
/**
 * @export
 */
export const WebhookTypeEnum = {
    CreatePaymentLink: 'create_payment_link'
} as const;
export type WebhookTypeEnum = typeof WebhookTypeEnum[keyof typeof WebhookTypeEnum];


/**
 * PaypalApi - axios parameter creator
 * @export
 */
export const PaypalApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Paypal configuration
         * @param {string} oid 
         * @param {CreatePaypalConfigRequest} [createPaypalConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createPaypalConfiguration: async (oid: string, createPaypalConfigRequest?: CreatePaypalConfigRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('createPaypalConfiguration', 'oid', oid)
            const localVarPath = `/integrations/paypal/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPaypalConfigRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletePaypalConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('deletePaypalConfiguration', 'oid', oid)
            const localVarPath = `/integrations/paypal/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPaypalConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('getPaypalConfiguration', 'oid', oid)
            const localVarPath = `/integrations/paypal/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PaypalApi - functional programming interface
 * @export
 */
export const PaypalApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PaypalApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Paypal configuration
         * @param {string} oid 
         * @param {CreatePaypalConfigRequest} [createPaypalConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createPaypalConfiguration(oid: string, createPaypalConfigRequest?: CreatePaypalConfigRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PaypalConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createPaypalConfiguration(oid, createPaypalConfigRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deletePaypalConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deletePaypalConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getPaypalConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PaypalConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getPaypalConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * PaypalApi - factory interface
 * @export
 */
export const PaypalApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PaypalApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Paypal configuration
         * @param {string} oid 
         * @param {CreatePaypalConfigRequest} [createPaypalConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createPaypalConfiguration(oid: string, createPaypalConfigRequest?: CreatePaypalConfigRequest, options?: any): AxiosPromise<PaypalConfiguration> {
            return localVarFp.createPaypalConfiguration(oid, createPaypalConfigRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletePaypalConfiguration(oid: string, options?: any): AxiosPromise<void> {
            return localVarFp.deletePaypalConfiguration(oid, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Paypal configuration
         * @param {string} oid 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPaypalConfiguration(oid: string, options?: any): AxiosPromise<PaypalConfiguration> {
            return localVarFp.getPaypalConfiguration(oid, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * PaypalApi - object-oriented interface
 * @export
 * @class PaypalApi
 * @extends {BaseAPI}
 */
export class PaypalApi extends BaseAPI {
    /**
     * 
     * @summary Create Paypal configuration
     * @param {string} oid 
     * @param {CreatePaypalConfigRequest} [createPaypalConfigRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaypalApi
     */
    public createPaypalConfiguration(oid: string, createPaypalConfigRequest?: CreatePaypalConfigRequest, options?: AxiosRequestConfig) {
        return PaypalApiFp(this.configuration).createPaypalConfiguration(oid, createPaypalConfigRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Paypal configuration
     * @param {string} oid 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaypalApi
     */
    public deletePaypalConfiguration(oid: string, options?: AxiosRequestConfig) {
        return PaypalApiFp(this.configuration).deletePaypalConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Paypal configuration
     * @param {string} oid 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaypalApi
     */
    public getPaypalConfiguration(oid: string, options?: AxiosRequestConfig) {
        return PaypalApiFp(this.configuration).getPaypalConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * SettingsApi - axios parameter creator
 * @export
 */
export const SettingsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions: async (organizationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getAvailableActions', 'organizationId', organizationId)
            const localVarPath = `/settings/organizations/{organizationId}/available-actions`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SettingsApi - functional programming interface
 * @export
 */
export const SettingsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SettingsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAvailableActions(organizationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AvailableActionsResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAvailableActions(organizationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SettingsApi - factory interface
 * @export
 */
export const SettingsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SettingsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions(organizationId: string, options?: any): AxiosPromise<AvailableActionsResponse> {
            return localVarFp.getAvailableActions(organizationId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SettingsApi - object-oriented interface
 * @export
 * @class SettingsApi
 * @extends {BaseAPI}
 */
export class SettingsApi extends BaseAPI {
    /**
     * 
     * @summary Get available actions for organization
     * @param {string} organizationId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SettingsApi
     */
    public getAvailableActions(organizationId: string, options?: AxiosRequestConfig) {
        return SettingsApiFp(this.configuration).getAvailableActions(organizationId, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * UnzerApi - axios parameter creator
 * @export
 */
export const UnzerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Unzer configuration
         * @param {string} oid Organization ID
         * @param {CreateUnzerConfigRequest} [createUnzerConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createUnzerConfiguration: async (oid: string, createUnzerConfigRequest?: CreateUnzerConfigRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('createUnzerConfiguration', 'oid', oid)
            const localVarPath = `/integrations/unzer/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createUnzerConfigRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteUnzerConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('deleteUnzerConfiguration', 'oid', oid)
            const localVarPath = `/integrations/unzer/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getUnzerConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('getUnzerConfiguration', 'oid', oid)
            const localVarPath = `/integrations/unzer/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UnzerApi - functional programming interface
 * @export
 */
export const UnzerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = UnzerApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Unzer configuration
         * @param {string} oid Organization ID
         * @param {CreateUnzerConfigRequest} [createUnzerConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createUnzerConfiguration(oid: string, createUnzerConfigRequest?: CreateUnzerConfigRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UnzerConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createUnzerConfiguration(oid, createUnzerConfigRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteUnzerConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteUnzerConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getUnzerConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UnzerConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getUnzerConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * UnzerApi - factory interface
 * @export
 */
export const UnzerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = UnzerApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Unzer configuration
         * @param {string} oid Organization ID
         * @param {CreateUnzerConfigRequest} [createUnzerConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createUnzerConfiguration(oid: string, createUnzerConfigRequest?: CreateUnzerConfigRequest, options?: any): AxiosPromise<UnzerConfiguration> {
            return localVarFp.createUnzerConfiguration(oid, createUnzerConfigRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteUnzerConfiguration(oid: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteUnzerConfiguration(oid, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Unzer configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getUnzerConfiguration(oid: string, options?: any): AxiosPromise<UnzerConfiguration> {
            return localVarFp.getUnzerConfiguration(oid, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UnzerApi - object-oriented interface
 * @export
 * @class UnzerApi
 * @extends {BaseAPI}
 */
export class UnzerApi extends BaseAPI {
    /**
     * 
     * @summary Create Unzer configuration
     * @param {string} oid Organization ID
     * @param {CreateUnzerConfigRequest} [createUnzerConfigRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UnzerApi
     */
    public createUnzerConfiguration(oid: string, createUnzerConfigRequest?: CreateUnzerConfigRequest, options?: AxiosRequestConfig) {
        return UnzerApiFp(this.configuration).createUnzerConfiguration(oid, createUnzerConfigRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Unzer configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UnzerApi
     */
    public deleteUnzerConfiguration(oid: string, options?: AxiosRequestConfig) {
        return UnzerApiFp(this.configuration).deleteUnzerConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Unzer configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UnzerApi
     */
    public getUnzerConfiguration(oid: string, options?: AxiosRequestConfig) {
        return UnzerApiFp(this.configuration).getUnzerConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }
}



